/************************************************************************
*									*
* The XOLDT System							*
* Author: David S. Warren						*
* V1.0 Copyright SUNY Stony Brook, 1992					*
* This code is distributed WITHOUT ANY WARRANTY.			*
*									*
************************************************************************/

/* Load this into user to run the xoldt system for well-founded-semantics
treatment of negation: ~. */

:- user:abolish(term_expansion,2).

:- use_module(xoldts).
:- use_module(xoldt_load).
:- use_module(library(lists)).
:- use_module(subsumes).

/* term_expansion must be defined in module user:, and it must call
directly into xoldt_load module. */

:- assertz(user:(
	term_expansion(X,Y) :- !,
		xoldt_load:do_term_expansion(X,Y)
	  )).


:- op(600,fx,~).

:- prolog member/2, (\+)/1.
:- notable (~)/1, wfnot/1, (?)/0.

~G :- \+ numbervars(G,0,0), write('FLOUNDER: '), write(G), nl, abort.
~G :- findall(C,G<-C,Anss),wfnot(Anss).

? :- xconstraint(?).

wfnot([]) :- !.
wfnot(Ans) :- \+ member([],Ans), xconstraint(?).


:- prolog xand/3, xcomp/3.
xand([],[],[]) :- !.	
xand(_,_,?).

xcomp(Op,[H|V],[H1|V1]) :- 
	variant(H,H1),
	(V == ? 
	 ->	Op=le 
	 ; V1==[] 
	 -> 	Op=le
	 ; Op=gt
	).

/********************** simple tests *********************/

:- table win/1.

win(X) :- move(X,Y), ~win(Y).

move(a,b).
move(b,a).
move(b,c).
move(c,d).

/***** trace
	| ?- win(X)<-C.
	X = a,
	C = ? ;		% win(a) is undefined in WFS.

	X = b,
	C = ? ;		% and so is win(b).

	X = c,
	C = [] ;	% win(c) is true.

	no		% and win(d) is false.
*******************************************/
